﻿Imports System
Imports System.IO
Imports System.Text

Public Class Form1
    Dim sortColumn As Integer = -1 'used to make cols on listview sortable
    Public ConStr As String 'Connection string global for database communication ease of use
    Public dbase As String 'So we can output to console which DB we read from
    Public inputpath As String
    Public outputpath As String

    Sub LoadCfgFile()
        '10/2/14 Tim Wray (original config source date)

        'This sub is not actually in use, it is from other programs I've written, and it's 
        'function is to load a config file in raw text format and specify connectivity
        'to a Microsoft SQL server for data storage of data derived from the synchronet logs.
        'I may or may not build this program out some day. I found I was satisfied with just 
        'viewing the files in the listview on the form. Good enough for now. (TW, 2/13/2016)

        Try
            FileOpen(1, "config.cfg", OpenMode.Input)
        Catch ex As Exception
            MsgBox(ex)
        End Try

        Dim sqlhost As String
        Dim initialcatalog As String
        Dim PersistSecurityInfo
        Dim sqllogin As String
        Dim sqlpassword As String

        sqlhost = LineInput(1)
        initialcatalog = LineInput(1)
        PersistSecurityInfo = LineInput(1)
        sqllogin = LineInput(1)
        sqlpassword = LineInput(1)
        inputpath = LineInput(1)
        outputpath = LineInput(1)
        'futurevar = LineInput(1)
        'futurevar = LineInput(1)
        FileClose(1)

        'build ConStr for DB
        ConStr = "Data Source=" + Trim(sqlhost) + ";Initial Catalog=" + Trim(initialcatalog) + ";Persist Security Info=" + Trim(PersistSecurityInfo) + ";User ID=" + Trim(sqllogin) + ";Password=" + Trim(sqlpassword)

        'Set this variable for display use in main sub
        dbase = "SRV=" + sqlhost + " DB=" + initialcatalog

    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        SortSomeCrap()
    End Sub

    Sub SortSomeCrap()
        '1/1/2016 Tim Wray
        ListView1.Items.Clear()

        If cbxDownloads.Checked = False And cbxLogons.Checked = False And cbxNewUsers.Checked = False _
        And cbxUploads.Checked = False And cbxXtrn.Checked = False And ckTextSearch.Checked = False Then
            MsgBox("Please select some filters.", MsgBoxStyle.Exclamation)
            Exit Sub
        End If
        Dim di As New DirectoryInfo(txtLogPath.Text + "\")
        Dim fiArr As FileInfo() = di.GetFiles()
        Dim fri As FileInfo
        Dim linestr As String = ""

        'get total files in dir that meet criteria (1/1/2016)
        'This is so we can set the progress bar maximum property
        Dim totfiles As Integer = 0
        For Each fri In fiArr
            If IsNumeric(Mid(fri.Name, 1, 1)) Then
                If UCase(Mid(fri.Name, (Len(fri.Name) - 2), 3)) = "LOG" Then
                    totfiles += 1
                End If
            End If
        Next

        ToolStripProgressBar1.Maximum = totfiles

        'Process the files
        '-----------------------------------------------------
        'reset totfiles to use for progress bar increments
        totfiles = 0
        For Each fri In fiArr
            If IsNumeric(Mid(fri.Name, 1, 1)) Then
                If UCase(Mid(fri.Name, (Len(fri.Name) - 2), 3)) = "LOG" Then

                    Dim reader As StreamReader = New StreamReader(di.FullName + fri.Name)
                    Do While reader.Peek() >= 0
                        linestr = reader.ReadLine

                        'user login:
                        If cbxLogons.Checked Then
                            If Mid(linestr, 1, 2) = "++" Then
                                If ckTextSearch.Checked Then
                                    If ContainsText(linestr, txtUser.Text) Then
                                        AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                    End If
                                Else
                                    AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                End If
                            End If
                        End If

                        'file downloads:
                        If cbxDownloads.Checked Then
                            If Mid(linestr, 1, 2) = "D-" Then
                                If ckTextSearch.Checked Then
                                    If ContainsText(linestr, txtUser.Text) Then
                                        AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                    End If
                                Else
                                    AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                End If
                            End If
                        End If

                        'file uploads:
                        If cbxUploads.Checked Then
                            If Mid(linestr, 1, 2) = "U+" Then
                                If ckTextSearch.Checked Then
                                    If ContainsText(linestr, txtUser.Text) Then
                                        AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                    End If
                                Else
                                    AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                End If
                            End If
                        End If
                        'door ran:
                        If cbxXtrn.Checked Then
                            If Mid(linestr, 1, 2) = "X-" Then
                                If ckTextSearch.Checked Then
                                    If ContainsText(linestr, txtUser.Text) Then
                                        AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                    End If
                                Else
                                    AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                End If
                            End If
                        End If

                        'New User created:
                        If cbxNewUsers.Checked Then
                            If Mid(linestr, 1, 1) = "N" Then
                                If ckTextSearch.Checked Then
                                    If ContainsText(linestr, txtUser.Text) Then
                                        AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                    End If
                                Else
                                    AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                                End If
                            End If
                        End If

                        'if none of the other boxes are checked but text search is, just look at every
                        'line of the file loaded for a match (1-5-2016)
                        If cbxLogons.Checked = False And cbxDownloads.Checked = False And cbxUploads.Checked = False And cbxNewUsers.Checked = False _
                        And cbxXtrn.Checked = False And ckTextSearch.Checked = True Then
                            If ContainsText(linestr, txtUser.Text) Then
                                AddToList(linestr, fri.Name, ReturnDateFromFileName(fri.Name))
                            End If
                        End If
                    Loop

                    reader.Dispose()

                    'increment progress bar
                    totfiles += 1
                    ToolStripProgressBar1.Value = totfiles

                End If
            End If

        Next
        ToolStripProgressBar1.Value = 0
    End Sub
    Sub AddToList(ByVal text As String, ByVal filename As String, ByVal filedate As String)
        'Adds txt to listview
        '(1/5/2016 Tim Wray)
        Dim lv As New ListViewItem
        lv.Text = text
        lv.SubItems.Add(filename)
        lv.SubItems.Add(filedate)
        ListView1.Items.Add(lv)
    End Sub
    Private Sub ListView1_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles ListView1.ColumnClick
        ' Determine whether the column is the same as the last column clicked.
        If e.Column <> sortColumn Then
            ' Set the sort column to the new column.
            sortColumn = e.Column
            ' Set the sort order to ascending by default.
            ListView1.Sorting = SortOrder.Ascending
        Else
            ' Determine what the last sort order was and change it.
            If ListView1.Sorting = SortOrder.Ascending Then
                ListView1.Sorting = SortOrder.Descending
            Else
                ListView1.Sorting = SortOrder.Ascending
            End If
        End If
        ' Call the sort method to manually sort.
        ListView1.Sort()
        ' Set the ListViewItemSorter property to a new ListViewItemComparer
        ' object.
        ListView1.ListViewItemSorter = New ListViewItemComparer(e.Column, _
                                                         ListView1.Sorting)
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ListView1.Items.Clear()

    End Sub


    'Feed the filename in, get the date out year first...(12/31/2015)
    Function ReturnDateFromFileName(ByVal fname As String)
        Dim fixed_date As String
        fixed_date = "20" + Mid(fname, 5, 2) + "-" + Mid(fname, 1, 2) + "-" + Mid(fname, 3, 2)
        Return fixed_date
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

  
    Private Sub btnBrowser_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowser.Click
        FolderBrowserDialog1.SelectedPath = txtLogPath.Text

        FolderBrowserDialog1.ShowDialog()
        txtLogPath.Text = FolderBrowserDialog1.SelectedPath
    End Sub

    Public Function ContainsText(ByVal textin As String, ByVal searchterm As String) As Boolean
        'implements a basic text search. Pass in textin as string to search in,
        'searchterm as string to search for within textin.
        '(1-5-2016 Tim Wray)
        Dim found As Boolean = False
        For pos = 1 To (Len(textin) + 1 - Len(searchterm))
            If UCase(Mid(textin, pos, Len(searchterm))) = UCase(searchterm) Then
                found = True
                Exit For
            End If
        Next
        If found Then
            Return True
        Else
            Return False
        End If
    End Function
End Class

'class borrowed from https://msdn.microsoft.com/en-us/library/ms996467.aspx
Class ListViewItemComparer
    Implements IComparer
    Private col As Integer
    Private order As SortOrder

    Public Sub New()
        col = 0
        order = SortOrder.Ascending
    End Sub

    Public Sub New(ByVal column As Integer, ByVal order As SortOrder)
        col = column
        Me.order = order
    End Sub

    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
                        Implements System.Collections.IComparer.Compare
        Dim returnVal As Integer = -1
        returnVal = [String].Compare(CType(x,  _
                        ListViewItem).SubItems(col).Text, _
                        CType(y, ListViewItem).SubItems(col).Text)
        ' Determine whether the sort order is descending.
        If order = SortOrder.Descending Then
            ' Invert the value returned by String.Compare.
            returnVal *= -1
        End If

        Return returnVal
    End Function
End Class
